/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            frame.cc
 *
 *  Mon Nov 15 19:45:07 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: frame.cc,v 1.6 2005/05/03 08:31:59 deva Exp $
 */

/*
 * $Log: frame.cc,v $
 * Revision 1.6  2005/05/03 08:31:59  deva
 * Removed the error object, and replaced it with a more generic info object.
 *
 * Revision 1.5  2005/05/01 09:56:26  deva
 * Added Id and Log tags to all files
 */

#include <config.h>
#include "frame.h"

#include "debug.h"

#include <memory.h>
#include <stdlib.h>

Frame::Frame(unsigned char *d, int sz)
{
  data = (unsigned char *)malloc(sz);
  if(d) memcpy(data, d, sz);
  size = sz;
}

Frame::~Frame()
{
  free(data);
  data = NULL;
  size = 0;
}

