/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            info_gui.cc
 *
 *  Tue May  3 09:34:59 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id$
 */

/*
 * $Log$
 */

#include <config.h>
#ifdef USE_GUI

#include "info_gui.h"

#include <stdio.h>
#include <stdarg.h>

#include "messagebox.h"

InfoGui::InfoGui(QApplication *a, QWidget *p): Info()
{
  qapp = a;
  parent = p;
}

InfoGui::~InfoGui()
{
}

void InfoGui::error(char *fmt, ...)
{
  char buf[1024];

  pthread_mutex_lock(&mutex);
  // Beginning of safezone

	va_list argp;
	va_start(argp, fmt);
  fprintf(stderr, "Error: ["); vfprintf(stderr, fmt, argp); fprintf(stderr, "]\n"); fflush(stderr);
	vsprintf(buf, fmt, argp);
	va_end(argp);

  fprintf(stderr, "<!"); fflush(stderr);
  qapp->lock();
  fprintf(stderr, "!"); fflush(stderr);
  MessageBox(parent, 
             TXT_ERROR_TITLE, 
             buf, 
             TYPE_OK, 
             ICON_ERROR).exec();
  fprintf(stderr, "!"); fflush(stderr);
  qapp->unlock();
  fprintf(stderr, "!>"); fflush(stderr);

  // End of safezone
  pthread_mutex_unlock(&mutex);
}

void InfoGui::warn(char *fmt, ...)
{
  char buf[1024];

  pthread_mutex_lock(&mutex);
  // Beginning of safezone

	va_list argp;
	va_start(argp, fmt);
  fprintf(stderr, "Warning: ["); vfprintf(stderr, fmt, argp); fprintf(stderr, "]\n"); fflush(stderr);
	vsprintf(buf, fmt, argp);
	va_end(argp);

  qapp->lock();
  MessageBox(parent, 
             TXT_WARNING_TITLE, 
             buf, 
             TYPE_OK, 
             ICON_WARNING).exec();
  qapp->unlock();

  // End of safezone
  pthread_mutex_unlock(&mutex);
}

void InfoGui::info(char *fmt, ...)
{
  char buf[1024];

  pthread_mutex_lock(&mutex);
  // Beginning of safezone

	va_list argp;
	va_start(argp, fmt);
  fprintf(stderr, "Info: ["); vfprintf(stderr, fmt, argp); fprintf(stderr, "]\n"); fflush(stderr);
	vsprintf(buf, fmt, argp);
	va_end(argp);

  qapp->lock();
  MessageBox(parent, 
             TXT_INFO_TITLE, 
             buf, 
             TYPE_OK, 
             ICON_INFO).exec();
  qapp->unlock();

  // End of safezone
  pthread_mutex_unlock(&mutex);
}

#endif/*USE_GUI*/
