/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            miav_config.h
 *
 *  Sat Feb 19 14:13:19 CET 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: miav_config.h,v 1.6 2005/05/03 08:31:59 deva Exp $
 */

/*
 * $Log: miav_config.h,v $
 * Revision 1.6  2005/05/03 08:31:59  deva
 * Removed the error object, and replaced it with a more generic info object.
 *
 * Revision 1.5  2005/05/01 09:56:26  deva
 * Added Id and Log tags to all files
 */

#include <config.h>
#ifndef __MIAV_MIAV_CONFIG_H__
#define __MIAV_MIAV_CONFIG_H__

#include <string>
using namespace std;

#include "info.h"

typedef struct __cfg {
  string *name;
  bool boolval;
  int intval;
  string *stringval;
  float floatval;
  struct __cfg* next;
} _cfg;

class MiavConfig {
public:
  MiavConfig(char *file, Info* ginfo);
  ~MiavConfig();

  int readInt(char *node);
  bool readBool(char *node);
  string *readString(char *node);
  float readFloat(char *node);

  Info* getInfoObj();

private:
  Info *info;

  string emptyString;
  string filename;
  _cfg *addConfig(_cfg *parent, char* conf);
  int parse(char* conf);
  char *strip(char* conf);
  _cfg *parseError(char* msg, char* line);
  _cfg *findNode(char* node);
  _cfg *configs;
};

extern MiavConfig *config;

#endif/*__MIAV_MIAV_CONFIG_H__*/
