/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            player.h
 *
 *  Fri Feb 25 20:23:19 CET 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 * Originally from:
 * RTVideoRec Realtime video recoder and encoder for Linux
 *
 * Copyright (C) 2004  Bent Bisballe
 * 
 */

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: player.h,v 1.7 2005/05/03 08:31:59 deva Exp $
 */

/*
 * $Log: player.h,v $
 * Revision 1.7  2005/05/03 08:31:59  deva
 * Removed the error object, and replaced it with a more generic info object.
 *
 * Revision 1.6  2005/05/01 09:56:26  deva
 * Added Id and Log tags to all files
 */

#include <config.h>
#ifdef USE_GUI

#ifndef __RTVIDEOREC_PLAYER_H
#define __RTVIDEOREC_PLAYER_H

#include "info.h"

#include <stdio.h>
#include <stdlib.h>
#include <semaphore.h>
#include <pthread.h>
#include <SDL/SDL.h>
//#include <avformat.h>

#include "util.h"
#include "queue.h"

#include "thread.h"
#include "frame.h"

#include <qwidget.h>

#define DISPLAYWIDTH	720	// FIXME: These numbers suck!
#define DISPLAYHEIGHT	576

/**
 * This class contains the SDL code, for displaying the movie frames
 * in the widget, using hardware overlay.
 */
class Player : public Thread {
public:
  Player(Info *ginfo,
         volatile int *grunning,
         sem_t	*gsem,
         Queue<Frame> *gqueue,
         pthread_mutex_t *gmutex);
  ~Player();

  void start();
  void stop();

  void run();

private:
  Info *info;

  void player();

  // Used to verify if errors ha ocurred previously.
  bool noErrors;

  volatile int *running;
  sem_t	*sem;
  Queue<Frame> *queue;
  pthread_mutex_t *mutex;

  sem_t	play_sem;

  SDL_Surface *screen;
  SDL_Overlay *overlay;
};

#endif

#endif /* USE_GUI */
