/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            socket.h
 *
 *  Mon Nov  8 10:49:33 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: socket.h,v 1.5 2005/05/03 17:13:25 deva Exp $
 */

/*
 * $Log: socket.h,v $
 * Revision 1.5  2005/05/03 17:13:25  deva
 * Fixed some missong Info object references.
 *
 * Revision 1.4  2005/05/03 08:31:59  deva
 * Removed the error object, and replaced it with a more generic info object.
 *
 * Revision 1.3  2005/05/01 09:56:26  deva
 * Added Id and Log tags to all files
 *
 */

#include <config.h>
#ifndef __MIAVLIB_SOCKET_H__
#define __MIAVLIB_SOCKET_H__

#include <stdio.h>
#include <string.h>

#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include "info.h"

class Socket {
public:
  Socket(Info *ginfo);
  Socket(u_short port, Info *ginfo);
  ~Socket();
  Socket slisten();
  int sconnect(char *ip);
  bool isConnected();

  struct sockaddr_in socketaddr;
  int ssocket;
  bool connected;

private:
  Info *info;
  int err;
};

#endif/*__SOCKET_H__*/
